"use strict";
exports.graphQLFetcher = function (subscriptionsClient, fallbackFetcher) {
    var activeSubscriptionId = null;
    return function (graphQLParams) {
        if (subscriptionsClient && activeSubscriptionId !== null) {
            subscriptionsClient.unsubscribe(activeSubscriptionId);
        }
        if (subscriptionsClient && graphQLParams.query.startsWith('subscription')) {
            return {
                subscribe: function (observer) {
                    observer.next('Your subscription data will appear here after server publication!');
                    activeSubscriptionId = subscriptionsClient.subscribe({
                        query: graphQLParams.query,
                        variables: graphQLParams.variables,
                    }, function (error, result) {
                        if (error) {
                            observer.error(error);
                        }
                        else {
                            observer.next(result);
                        }
                    });
                },
            };
        }
        else {
            return fallbackFetcher(graphQLParams);
        }
    };
};
//# sourceMappingURL=graphiql-fetcher.js.map